﻿#include <common>
#include <winuser>
class CWNDCLASSEX
{
	static CS_VREDRAW := 0x0001, CS_HREDRAW := 0x0002, CS_DBLCLKS := 0x0008, CS_OWNDC := 0x0020, CS_CLASSDC := 0x0040, CS_PARENTDC := 0x0080, CS_NOCLOSE := 0x0200, CS_SAVEBITS := 0x0800, CS_BYTEALIGNCLIENT := 0x1000, CS_BYTEALIGNWINDOW := 0x2000, CS_GLOBALCLASS := 0x4000
	__New(szClassName, szWindowName)
	{
		this.style := this.CS_VREDRAW | this.CS_HREDRAW
		this.szClassName := szClassName
		this.szWindowName := szWindowName
		this.cbClsExtra := 0
		this.cbWndExtra := 0
		this.hInstance := 0
		this.hIcon := 0
		this.hCursor := 0
		this.hbrBackground := 0
		this.hIconSm := 0
	}
}
class CCWEX
{
	static WS_OVERLAPPED := 0x00000000, WS_POPUP := 0x80000000, WS_CHILD := 0x40000000, WS_MINIMIZE := 0x20000000, WS_VISIBLE := 0x10000000, WS_DISABLED := 0x08000000, WS_CLIPSIBLINGS := 0x04000000, WS_CLIPCHILDREN := 0x02000000, WS_MAXIMIZE := 0x01000000, WS_CAPTION := 0x00C00000, WS_BORDER := 0x00800000, WS_DLGFRAME := 0x00400000, WS_VSCROLL := 0x00200000, WS_HSCROLL := 0x00100000, WS_SYSMENU := 0x00080000, WS_THICKFRAME := 0x00040000, WS_GROUP := 0x00020000, WS_TABSTOP := 0x00010000, WS_MINIMIZEBOX := 0x00020000, WS_MAXIMIZEBOX := 0x00010000
	static WS_TILED := CCWEX.WS_OVERLAPPED, WS_ICONIC := CCWEX.WS_MINIMIZE, WS_SIZEBOX := CCWEX.WS_THICKFRAME
	static WS_OVERLAPPEDWINDOW := CCWEX.WS_OVERLAPPED |  CCWEX.WS_CAPTION | CCWEX.WS_SYSMENU |  CCWEX.WS_THICKFRAME | CCWEX.WS_MINIMIZEBOX | CCWEX.WS_MAXIMIZEBOX
	static WS_TILEDWINDOW := CCWEX.WS_OVERLAPPEDWINDOW
	static CW_USEDEFAULT := 0x80000000
	__New(szClassName, szWindowName)
	{
		this.szClassName := szClassName
		this.szWindowName := szWindowName
		this.dwStyle := 0
		this.dwExStyle := 0
		this.x := this.CW_USEDEFAULT
		this.y :=this.CW_USEDEFAULT
		this.nWidth := this.CW_USEDEFAULT
		this.nHeight := this.CW_USEDEFAULT
		this.hWndParent := 0
		this.hMenu := 0
		this.hInstance := 0
		this.lpParam := 0
	}
}
class CMenu
{
	static MF_INSERT := 0x00000000, MF_CHANGE := 0x00000080, MF_APPEND := 0x00000100, MF_DELETE := 0x00000200, MF_REMOVE := 0x00001000, MF_BYCOMMAND := 0x00000000, MF_BYPOSITION := 0x00000400, MF_SEPARATOR := 0x00000800, MF_ENABLED := 0x00000000, MF_GRAYED := 0x00000001, MF_DISABLED := 0x00000002, MF_UNCHECKED := 0x00000000, MF_CHECKED := 0x00000008, MF_USECHECKBITMAPS := 0x00000200, MF_STRING := 0x00000000, MF_BITMAP := 0x00000004, MF_OWNERDRAW := 0x00000100, MF_POPUP := 0x00000010, MF_MENUBARBREAK := 0x00000020, MF_MENUBREAK := 0x00000040, MF_UNHILITE := 0x00000000, MF_HILITE := 0x00000080, MF_DEFAULT := 0x00001000, MF_SYSMENU := 0x00002000, MF_HELP := 0x00004000, MF_RIGHTJUSTIFY := 0x00004000, MF_MOUSESELECT := 0x00008000
	__New()
	{
		this.hMenu := DllCall("CreateMenu")
	}
	AppendMenu(flags, id, item)
	{
		return DllCall("AppendMenu", "ptr", this.hMenu, "uint", flags, "ptr", id, "str", item)
	}
	GetSubMenu(pos)
	{
		return DllCall("GetSubMenu", "ptr", this.hMenu, "int", pos)
	}
}
class CWindow
{
	static _inst := Object()
	static _inst_create := ""
	static _wndproc := RegisterCallback(CWindow.WndProc, "" , 4)
	static _enumchildproc := RegisterCallback(CWindow.EnumChildProc, "" , 2)
	__New(hWnd := 0)
	{
		TRACE(A_LineFile, A_LineNumber, A_Thisfunc)
		this.hWnd := hWnd
	}
	__Delete()
	{
		TRACE(A_LineFile, A_LineNumber, A_Thisfunc)
	}
	ListenMessage(hWnd)
	{
		TRACE(A_LineFile, A_LineNumber, A_Thisfunc)
		this._inst[hWnd] := this
	}
	IsWindow()
	{
		return DllCall("IsWindow", "ptr", this.hWnd)
	}
	GetWindow(uCmd)
	{
		return DllCall("GetWindow", "ptr", this.hWnd, "uint", uCmd)
	}
	GetParent()
	{
		return DllCall("GetParent", "ptr", this.hWnd)
	}
	LogWindowMessage(Func, uMsg, wParam, lParam)
	{
		for name, val in CWindowMessage
		{
			if (uMsg = val)
			{
				LogMessage(Func ": " name " (" wParam ", " lParam ")")
				return true
			}
		}
		LogMessage(Func ": Unknown Message")
		return false
	}
	DrawMenuBar()
	{
		return DllCall("DrawMenuBar", "ptr", this.hWnd)
	}
	SendMessage(uMsg, wParam, lParam)
	{
		return DllCall("SendMessage", "ptr", this.hWnd, "uint", uMsg, "uptr", wParam, "ptr", lParam)
	}
	PostMessage(uMsg, wParam, lParam)
	{
		return DllCall("PostMessage", "ptr", this.hWnd, "uint", uMsg, "uptr", wParam, "ptr", lParam)
	}
	SetMenu(hMenu)
	{
		DllCall("SetMenu", "ptr", this.hWnd, "ptr", hMenu)
	}
	ShowWindow(bShow := true)
	{
		return DllCall("ShowWindow", "ptr", this.hWnd, "int", bShow)
	}
	UpdateWindow()
	{
		return DllCall("UpdateWindow", "ptr", this.hWnd)
	}
	SetWindowClassInfo()
	{
	}
	SetCreateWindowInfo()
	{
	}
	RegisterEx(szClassName, szWindowName)
	{
		this.wcex := new CWNDCLASSEX(szClassName, szWindowName)
		this.SetWindowClassInfo()
		return this.RegisterClassEx(this.wcex.style, this.wcex.cbClsExtra, this.wcex.cbWndExtra, this.wcex.hInstance
			, this.wcex.hIcon, this.wcex.hCursor, this.wcex.hbrBackground, this.wcex.szMenuName, this.wcex.szClassName, this.wcex.hIconSm)
	}
	RegisterClassEx(style, cbClsExtra, cbWndExtra, hInstance, hIcon, hCursor, hbrBackground, lpszMenuName, lpszClassName, hIconSm)
	{
		TRACE(A_LineFile, A_LineNumber, A_Thisfunc)
		lpfnWndProc := this._wndproc
		cbSize := VarSetCapacity(wcex, A_PtrSize == 8 ? 80 : 48, 0)
		NumPut(cbSize, wcex, 0, "UInt")
		NumPut(style, wcex, 4, "UInt")
		NumPut(lpfnWndProc, wcex, 8, "Ptr")
		NumPut(cbClsExtra, wcex, A_PtrSize == 8 ? 16 : 12, "Int")
		NumPut(cbWndExtra, wcex, A_PtrSize == 8 ? 20 : 16, "Int")
		NumPut(hInstance, wcex, A_PtrSize == 8 ? 24 : 20, "Ptr")
		NumPut(hIcon, wcex, A_PtrSize == 8 ? 32 : 24, "Ptr")
		NumPut(hCursor, wcex, A_PtrSize == 8 ? 40 : 28, "Ptr")
		NumPut(hbrBackground, wcex, A_PtrSize == 8 ? 48 : 32, "Ptr")
		NumPut(&lpszMenuName, wcex, A_PtrSize == 8 ? 56 : 36, "Ptr")
		NumPut(&lpszClassName, wcex, A_PtrSize == 8 ? 64 : 40, "Ptr")
		NumPut(hIconSm, wcex, A_PtrSize == 8 ? 72 : 44, "Ptr")
		return DllCall("RegisterClassEx", "ptr", &wcex)
	}
	CreateEx(szClassName := "", szWindowName := "")
	{
		if (this.wcex)
		{
			if (!szClassName)
			{
				szClassName := this.wcex.szClassName
			}
			if (!szWindowName)
			{
				szWindowName := this.wcex.szWindowName
			}
		}
		this.cwex := new CCWEX(szClassName, szWindowName)
		this.SetCreateWindowInfo()
		return this.CreateWindowEx(this.cwex.dwExStyle, this.cwex.szClassName, this.cwex.szWindowName, this.cwex.dwStyle
			, this.cwex.x, this.cwex.y, this.cwex.nWidth, this.cwex.nHeight, this.cwex.hWndParent, this.cwex.hMenu, this.cwex.hInstance, this.cwex.lpParam)
	}
	CreateWindowEx(dwExStyle, lpClassName,lpWindowName,dwStyle,x,y,nWidth,nHeight,hWndParent,hMenu,hInstance,lpParam)
	{
		TRACE(A_LineFile, A_LineNumber, A_Thisfunc)
		CWindow._inst_create := this
		this.hWnd := DllCall("CreateWindowEx",  "Uint",   dwExStyle, "ptr",   &lpClassName, "ptr",   &lpWindowName, "Uint",   dwStyle
		  , "int",   x, "int",   y, "int",   nWidth, "int",   nHeight
		  , "ptr",   hWndParent, "ptr",   hMenu, "ptr",   hInstance, "ptr",   lpParam)	 
		 return this.hWnd
	}
	MessageLoop()
	{
		VarSetCapacity(msg, A_PtrSize == 8 ? 48 : 28, 0)
		while(DllCall("GetMessage", "ptr", &msg, "ptr", 0, "uint", 0, "uint", 0))
		{
			DllCall("TranslateMessage", "ptr", &msg)
			DllCall("DispatchMessage", "ptr", &msg)
		}
	}
	OnCreate(hWnd, uMsg, wParam, lParam)
	{
		return 0
	}
	OnMessage(hWnd, uMsg, wParam, lParam)
	{
		return false
	}
	EnumChildWindows(lParam)
	{
		this.ListenMessage(this.hWnd)
		return DllCall("EnumChildWindows", "ptr", this.hWnd, "ptr", this._enumchildproc, "ptr", lParam)
	}
	SubclassWindow()
	{
		this.ListenMessage(this.hWnd)
		GWL_WNDPROC := -4
		if (A_PtrSize = 8)
		{
			this.pWndProcOld := DllCall("SetWindowLongPtr", "ptr", this.hwnd, "int", GWL_WNDPROC, "Ptr", this._wndproc, "Ptr")
		}
		else
		{
			this.pWndProcOld := DllCall("SetWindowLongPtr", "int", this.hwnd, "int", GWL_WNDPROC, "Ptr", this._wndproc, "Ptr")
		}	
		return this.pWndProcOld
	}
	WndProc(uMsg, wParam, lParam)
	{
		static WM_CREATE := 0x0001, WM_DESTROY := 0x0002
		hWnd := this
		if (uMsg = WM_CREATE)
		{
			LogMessage("WM_CREATE " hWnd)
			_this := CWindow._inst_create
			if (_this)
			{
				CWindow._inst_create := ""
				_this.ListenMessage(hWnd)
				return _this.OnCreate(hWnd, uMsg, wParam, lParam)
			}
			return 0
		}
		instance := CWindow._inst[hWnd]
		if (instance)
		{
			if (uMsg = WM_DESTROY)
			{
				LogMessage("Clear instance " hWnd)
				CWindow._inst[hWnd] := ""
			}
			if (instance.OnMessage(hWnd, uMsg, wParam, lParam))
			{
				return 0
			}
			if (instance.pWndProcOld)
			{
				; SubclassWindow
				return DllCall("CallWindowProc", "Ptr" , instance.pWndProcOld, "Ptr", hWnd, "UInt" ,uMsg, "UPtr",wParam, "Ptr",lParam)
			}
			return instance.DefaultWindowProc(hWnd, uMsg, wParam, lParam)
		}
		return CWindow.DefaultWindowProc(hWnd, uMsg, wParam, lParam)
	}
	OnChildWindow(hWnd, lParam)
	{
	}
	EnumChildProc(lParam)
	{
		TRACE(A_LineFile, A_LineNumber, A_Thisfunc)
		hWnd := this
		hWndParent := DllCall("GetParent", "ptr", hWnd)
		instance := CWindow._inst[hWndParent]
		if (instance)
		{
			return instance.OnChildWindow(hWnd, lParam)
		}
		return true
	}
	DefaultWindowProc(hWnd, uMsg, wParam, lParam)
	{
		return DllCall("DefWindowProc", "Ptr", hWnd, "UInt" ,uMsg, "UPtr", wParam, "Ptr",lParam)
	}
}
class CFrameWindow extends CWindow
{
	__New(szClassName, szWindowName)
	{
		TRACE(A_LineFile, A_LineNumber, A_Thisfunc)
		base.__New()
		this.RegisterEx(szClassName, szWindowName)
		this.id_last := 100
		this.InitMenu()
	}
	InitMenu()
	{
		this.menu := new CMenu()
		this.AddMenu()
	}
	SetWindowClassInfo()
	{
		this.wcex.hIcon := this.GetIcon()
		this.wcex.hCursor := this.GetCursor()
		this.wcex.hbrBackground := this.GetBackgroundBrush()
	}
	SetCreateWindowInfo()
	{
		TRACE(A_LineFile, A_LineNumber, A_Thisfunc)
		this.cwex.dwStyle := CCWEX.WS_OVERLAPPEDWINDOW
		this.cwex.hMenu := this.menu.hMenu
	}
	AddMenu()
	{
		this.ID_FILE_EXIT := this.id_last++
		file := new CMenu()
		file.AppendMenu(CMenu.MF_STRING, this.ID_FILE_EXIT, "종 료(&X)")
		this.menu.AppendMenu(CMenu.MF_POPUP, file.hMenu, "파일(&F)")
	}
	GetBackgroundBrush()
	{
		COLOR_WINDOWFRAME := 6
		return COLOR_WINDOWFRAME
	}
	GetIcon()
	{
		hModule := DllCall("LoadLibrary", "str", "shell32.dll", "ptr")
		IMAGE_ICON := 1
		LR_SHARED := 0x00008000, LR_DEFAULTSIZE := 0x00000040
		idx := 35
		return DllCall("LoadImage", "ptr", hModule, "Uint", idx, "Uint", IMAGE_ICON, "int", 0, "int", 0, "Uint", LR_SHARED | LR_DEFAULTSIZE, "ptr")
	}
	GetCursor()
	{
		IDC_ARROW := 32512
		return DllCall("LoadCursor", "ptr", 0, "ptr", IDC_ARROW)
	}
	OnCreate(hWnd, uMsg, wParam, lParam)
	{
		TRACE(A_LineFile, A_LineNumber, A_Thisfunc)
	}
	OnSize(w, h)
	{
		LogMessage("OnSize (" w "," h ")")
		return false
	}
	OnCommand(hWnd, uMsg, wParam, lParam)
	{
		id := wParam & 0xFFFF
		if (id = this.ID_FILE_EXIT)
		{
			DllCall("DestroyWindow", "ptr", hWnd)
			return true
		}
		return false
	}
	OnSysCommand(hWnd, uMsg, wParam, lParam)
	{
		TRACE(A_LineFile, A_LineNumber, A_Thisfunc)
		return false
	}
	OnPaint()
	{
		VarSetCapacity(ps, A_PtrSize == 8 ? 72 : 64, 0)
		hdc := DllCall("BeginPaint", "ptr", hWnd, "ptr", &ps)
		;TODO: Add any drawing code that uses hdc here...
		DllCall("EndPaint", "ptr", hWnd, "ptr", &ps)
	}
	OnMessage(hWnd, uMsg, wParam, lParam)
	{
		static __ := CWindowMessage
		if (uMsg = __.WM_SIZE)
		{
			return this.OnSize(lParam & 0xFFFF, lParam >> 16)
		}
		else if (uMsg = __.WM_PAINT)
		{
			this.OnPaint()
		}		
		else if (uMsg = __.WM_COMMAND)
		{
			return this.OnCommand(hWnd, uMsg, wParam, lParam)
		}
		else if (uMsg = __.WM_SYSCOMMAND)
		{
			return this.OnSysCommand(hWnd, uMsg, wParam, lParam)
		}
		else if (uMsg = __.WM_DESTROY) 
		{
			LogMessage("WM_DESTROY")
			DllCall("PostQuitMessage", "int", 0)
			return true
		}
		return 0
	}
}

